

function openWindow(url, name) {
  popupWin = window.open(url, name, 'scrollbars,resizable, width=400,height=150'); 
}

function checkmanager(){
  if ((document.indexform.manager.value == "") || 
      ((document.indexform.manager.value.search(/[0-9]+((\.|\:|-)[0-9]+)[:[0-9]+]?$/) != -1) &&  
      (document.indexform.manager.value.search(/[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+[:[0-9]+]?$/) == -1))){
    alert("Please enter a valid overlay manager name " + document.indexform.manager.value + 
	  ". The correct format is <hostname>[:port]"); 
    return false;
  }
  return true; 
}

function disable_dummynet(type){
  document.myform.dn_en_delay.disabled = type; 
  document.myform.dn_delay.disabled = type; 
  document.myform.dn_en_bw.disabled = type; 
  document.myform.dn_bw.disabled = type; 
  document.myform.dn_en_q.disabled = type; 
  document.myform.dn_q.disabled = type; 
  document.myform.dn_en_plr.disabled = type; 
  document.myform.dn_plr.disabled = type; 
  document.myform.dn_bw_u.disabled = type;     
  document.myform.dn_q_u.disabled = type;       
}

function disable_ipsec(type){
  document.myform.ah.disabled = type; 
  document.myform.esp.disabled = type; 
  
}
//
// disable parts that are not appropriate 
// e.g., v6 should disable linux 
// 
function process_addresstype(){
  if (document.myform.address_type.value == "ipv6") {
    document.myform.host_os_linux.disabled = true; 
    document.myform.router_os_linux.disabled = true; 
    document.myform.host_os_cisco.disabled = true; 
    document.myform.router_os_cisco.disabled = true; 
    disable_dummynet(true);
    //disable_ipsec(true);
  } else {
    document.myform.host_os_linux.disabled = false; 
    document.myform.router_os_linux.disabled = false; 
    document.myform.host_os_cisco.disabled = false; 
    document.myform.router_os_cisco.disabled = false; 
    disable_dummynet(false);
    //disable_ipsec(false);
  }
}

//
// process topology 
// enable custom netlist only when topology is custom. 

function process_topology(){
  if (document.myform.topology.value == "custom") {  
    document.myform.hosts.disabled = true; 
    document.myform.routers.disabled = true; 
    document.myform.custom_netlist.disabled = false; 
  } else {
    document.myform.hosts.disabled = false; 
    document.myform.routers.disabled = false; 
    document.myform.custom_netlist.disabled = true; 
  }
}

// when cisco is enabled, disable the dummynet and ipsec 
function process_cisco() {
  if ((document.myform.host_os_cisco.checked == true) || 
      (document.myform.router_os_cisco.checked == true)){
    disable_dummynet(true); 
    disable_ipsec(true); 
  } else {
    disable_dummynet(false);
    disable_ipsec(false); 
  }  
}

// when cisco is enabled, disable the dummynet and ipsec 
function process_appdeployment() {
  if (document.myform.app.checked == true){
    document.myform.app_script.disabled=false;
    document.myform.suid.disabled=false;
  } else {
    document.myform.app_script.disabled=true;
    document.myform.suid.disabled=true;
  }  
}

//hostlist 
function process_hostlist() {
  if (document.myform.hostlist.checked == true){
    document.myform.custom_hostlist.disabled=false;
  } else {
    document.myform.custom_hostlist.disabled=true;
  }  
}

//
//
//

// name - name of the cookie
// value - value of the cookie
// [expires] - expiration date of the cookie (defaults to end of current session)
// [path] - path for which the cookie is valid (defaults to path of calling document)
// [domain] - domain for which the cookie is valid (defaults to domain of calling document)
// [secure] - Boolean value indicating if the cookie transmission requires a secure transmission
// * an argument defaults when it is assigned null as a placeholder
// * a null placeholder is not required for trailing omitted arguments
//function setCookie(name, value, expires, path, domain, secure) {
//  var curCookie = name + "=" + escape(value) +
//      ((expires) ? "; expires=" + expires.toGMTString() : "") +
//      ((path) ? "; path=" + path : "") +
//      ((domain) ? "; domain=" + domain : "") +/
//      ((secure) ? "; secure" : "");
//  document.cookie = curCookie;
//}

// name - name of the desired cookie
// * return string containing value of specified cookie or null if cookie does not exist
function getCookie(name) {
  
  var dc = document.cookie;
  var prefix = name + "=";
  var begin = dc.indexOf("; " + prefix);
  if (begin == -1) {
    begin = dc.indexOf(prefix);
    if (begin != 0) return "";
  } else
    begin += 2;
  var end = document.cookie.indexOf(";", begin);
  if (end == -1)
    end = dc.length;
  var retval = unescape(dc.substring(begin + prefix.length, end));
  
  return retval; 
}

function readCookie(name)
{
  
   var the_values= getCookie(name); 
   var info= new Array();
   if (typeof(the_values) == "undefined" || the_values == ""){   
     return info; 
   }
   //var the_cookie = unescape(the_cookie);
   //var broken_cookie = the_cookie.split("=");
   //var the_values = broken_cookie[1];
   var separated = the_values.split("+");
   var property_value="";


   for ( var loop = 0; loop < separated.length; loop++)
   {
     property_value = separated[loop];
     var broken_info = property_value.split("!");
     var the_property = broken_info[0];
     var the_value = broken_info[1];
     info[the_property]=the_value;
   }
   return info;
}

function loadCookies() {   

  
  if ( typeof(document.cookie) == "undefined" || document.cookie == "") {

    with(document.myform){        

     mcast_radius.value="5";
     name.value="";
     address_type.value="ipv4";
     topology.value="star";
     app_script.value=""; 
     custom_netlist.value="";
     custom_hostlist.value="";
     hosts.value="1";
     routers.value="1";
     dn_plr.value= "0";
     dn_q.value="100";
     dn_delay.value="100";
     dn_bw.value="10";
     app.checked=false;
     hostlist.checked=false;
     dns.checked=true;
     dn_en_plr.checked=false;
     dn_en_q.checked=false;
     dn_en_delay.checked=false;
     dn_en_bw.checked=false;
     dyn_routing.checked=false;
     host_os_freebsd.checked=true;
     host_os_linux.checked=false;
     host_os_cisco.checked=false;
     router_os_freebsd.checked=true;
     router_os_linux.checked=false;
     router_os_cisco.checked=false;
     esp.value="undef";
     ah.value="undef";
     dn_q_u.value="byte";
     dn_bw_u.value="Mbit";
     suid.value="undef"; 
   }
   return true; 
  } 

  var stringVariables = new Array(
     "mcast_radius",  "name", "address_type", "app_script", 
     "custom_netlist", "custom_hostlist", 
     "hosts", "routers", "dn_plr", "dn_q",
     "dn_delay", "dn_bw", "topology");  

  var selectVariable = new Array(
      "esp", "ah", "dn_bw_u", "dn_q_u", "suid"
   ); 

  var boolVariables = new Array(
     "app", "dns", "dyn_routing", "hostlist", 
     "host_os_freebsd", "host_os_linux", "host_os_cisco", 
     "router_os_freebsd", "router_os_linux", "router_os_cisco", 
     "dn_en_plr", "dn_en_q", "dn_en_delay",
     "dn_en_bw"); 

  var cookie_information = new Array();
  cookie_information = readCookie("XBoneCookie");
  var undef = "undefined"; 

  for (i in stringVariables)
  {   

    var test = stringVariables[ i ]; 
    var status = cookie_information[ test ] ;        
    if (typeof(status) == "undefined") {
      cookie_information[ test ] = ""; 
    } 
  }

  for (i in boolVariables)
  {   
    var test = boolVariables[ i ]; 
    var status = cookie_information[ test ] ;        
    if (typeof(status) == "undefined") {
      cookie_information[ test ] = "false"; 
    } 
  }

  if (typeof(cookie_information[ "esp" ]) == "undefined") 
      cookie_information[ "esp" ] = "undef"; 
  if (typeof(cookie_information[ "ah" ]) == "undefined") 
      cookie_information[ "ah" ] = "undef"; 
  if (typeof(cookie_information[ "dn_bw_u" ]) == "undefined") 
      cookie_information[ "dn_bw_u" ] = "Kbytes"; 
  if (typeof(cookie_information[ "dn_q_u" ]) == "undefined") 
      cookie_information[ "dn_q_u" ] = "byte"; 
  if (typeof(cookie_information[ "suid" ]) == "undefined") 
      cookie_information[ "suid" ] = "undef"; 
  

  with(document.myform){        

     mcast_radius.value=cookie_information["mcast_radius"]; 
     name.value=cookie_information["name"];
     address_type.value=cookie_information["address_type"];
     topology.value=cookie_information["topology"];
     app_script.value=cookie_information["app_script"];
     custom_hostlist.value=cookie_information["custom_hostlist"];
     custom_netlist.value=cookie_information["custom_netlist"];
     hosts.value=cookie_information["hosts"];
     routers.value=cookie_information["routers"];
     dn_plr.value=cookie_information["dn_plr"];
     dn_q.value=cookie_information["dn_q"];
     dn_delay.value=cookie_information["dn_delay"];
     dn_bw.value=cookie_information["dn_bw"];

     hostlist.checked=("true" == cookie_information["hostlist"]); 
     app.checked=("true" == cookie_information["app"]); 
     dns.checked=("true" == cookie_information["dns"]); 
     dn_en_plr.checked=("true" == cookie_information["dn_en_plr"]); 
     dn_en_q.checked=("true" == cookie_information["dn_en_q"]); 
     dn_en_delay.checked=("true" == cookie_information["dn_en_delay"]); 
     dn_en_bw.checked=("true" == cookie_information["dn_en_bw"]); 
     dyn_routing.checked=("true" == cookie_information["dyn_routing"]);
     host_os_freebsd.checked=("true" == cookie_information["host_os_freebsd"]); 
     host_os_linux.checked=("true" == cookie_information["host_os_linux"]); 
     host_os_cisco.checked=("true" == cookie_information["host_os_cisco"]); 
     router_os_freebsd.checked=("true" == cookie_information["router_os_freebsd"]); 
     router_os_linux.checked=("true" == cookie_information["router_os_linux"]); 
     router_os_cisco.checked=("true" == cookie_information["router_os_cisco"]); 

     esp.value=cookie_information["esp"]; 
     ah.value=cookie_information["ah"]; 
     dn_q_u.value=cookie_information["dn_q_u"]; 
     dn_bw_u.value=cookie_information["dn_bw_u"]; 
     suid.value=cookie_information["suid"]; 
     
  }
  
  process_addresstype();
  process_topology();
  process_cisco();
  process_appdeployment();
  process_hostlist();
}

function storeCookies() {

   var the_date=new Date("December 31, 2023");
   var cookieDate=the_date.toGMTString();

   var the_cookie="XBoneCookie=" 
            +escape(
                    "name!" + document.myform.name.value+
                    "+address_type!" + document.myform.address_type.value+
                    "+mcast_radius!" + document.myform.mcast_radius.value+
                    "+app_script!" + document.myform.app_script.value+
                    "+topology!" + document.myform.topology.value+
                    "+custom_hostlist!" + document.myform.custom_hostlist.value+
                    "+custom_netlist!" + document.myform.custom_netlist.value+
                    "+hosts!" + document.myform.hosts.value+
                    "+routers!" + document.myform.routers.value+
                    "+dn_plr!" + document.myform.dn_plr.value+
                    "+dn_q!" + document.myform.dn_q.value+
                    "+dn_delay!" + document.myform.dn_delay.value+
                    "+dn_bw!" + document.myform.dn_bw.value+
                    "+app!" + document.myform.app.checked+
                    "+hostlist!" + document.myform.hostlist.checked+
                    "+host_os_freebsd!" + document.myform.host_os_freebsd.checked+
                    "+host_os_linux!" + document.myform.host_os_linux.checked+
                    "+host_os_cisco!" + document.myform.host_os_cisco.checked+
                    "+router_os_freebsd!" + document.myform.router_os_freebsd.checked+
                    "+router_os_linux!" + document.myform.router_os_linux.checked+
                    "+router_os_cisco!" + document.myform.router_os_cisco.checked+
                    "+dyn_routing!" + document.myform.dyn_routing.checked+
                    "+dns!" + document.myform.dns.checked+
                    "+dn_en_plr!" + document.myform.dn_en_plr.checked+
                    "+dn_en_q!" + document.myform.dn_en_q.checked+
                    "+dn_en_delay!" + document.myform.dn_en_delay.checked+
                    "+dn_en_bw!" + document.myform.dn_en_bw.checked+
                    "+dn_bw_u!" + document.myform.dn_bw_u.value+
                    "+dn_q_u!" + document.myform.dn_q_u.value+
                    "+esp!" + document.myform.esp.value+
                    "+suid!" + document.myform.suid.value+
                    "+ah!" + document.myform.ah.value );

   the_cookie=the_cookie + ";expires=" + cookieDate ;
   document.cookie=the_cookie;
}

function indexformStoreCookies() {
  
  if ( ! checkmanager()) {
    return false; 
  }
   var the_date=new Date("December 31, 2023");
   var cookieDate=the_date.toGMTString();

   var the_cookie="XboneIndexCookie=" 
            +escape(
                    "manager!" + document.indexform.manager.value);
   the_cookie=the_cookie + ";expires=" + cookieDate ;

   document.cookie=the_cookie;
}

function indexformLoadCookies() {   

  if ( typeof(document.cookie) == "undefined" 
       || document.cookie == "") {
    return; 
  }
  cookie_information = readCookie("XboneIndexCookie");
  with(document.indexform){        
    if (typeof(cookie_information["manager"]) != "undefined"){ 
      manager.value=cookie_information["manager"]; 
    } 
  }
}


function discoverformStoreCookies() {

   var the_date=new Date("December 31, 2023");
   var cookieDate=the_date.toGMTString();
   
   var the_cookie="XboneDiscoverCookie=" 
            +escape(
                    //"manager!" + document.discoverform.manager.value+
                    "mcast_radius!" + document.discoverform.mcast_radius.value+
                    "+timeout!" + document.discoverform.timeout.value+
                    "+custom_hostlist!" + document.discoverform.custom_hostlist.value+
	            "+hostlist!" + document.discoverform.hostlist.checked);
   the_cookie=the_cookie + ";expires=" + cookieDate ;

   document.cookie=the_cookie;
}

//hostlist 
function process_discover_hostlist() {
  if (document.discoverform.hostlist.checked == true){
    document.discoverform.custom_hostlist.disabled=false;
  } else {
    document.discoverform.custom_hostlist.disabled=true;
  }  
}

function discoverformLoadCookies() {   

  if ( typeof(document.cookie) == "undefined" || document.cookie == "") {
    return; 
  }
  cookie_information = readCookie("XboneDiscoverCookie");
  with(document.discoverform){        

    //if ((typeof(manager.value) == "undefined") && 
    //	typeof(cookie_information["manager"]) != "undefined"){ 
    // manager.value=cookie_information["manager"]; 
    //} 
    if (typeof(cookie_information["mcast_radius"]) != "undefined"){ 
      mcast_radius.value=cookie_information["mcast_radius"]; 
    } 
    if (typeof(cookie_information["timeout"]) != "undefined"){ 
      timeout.value=cookie_information["timeout"]; 
    } 
    if (typeof(cookie_information["custom_hostlist"]) != "undefined"){ 
      custom_hostlist.value=cookie_information["custom_hostlist"]; 
    } 

    hostlist.checked=("true" == cookie_information["hostlist"]); 	

  }

 process_discover_hostlist(); 
}
